/*-----------------------------------------------------------------------

File  : clb_simple_stuff.c

Author: Stephan Schulz

Contents
 
  Useful routines, usually pretty trivial.

  Copyright 1998, 1999 by the author.
  This code is released under the GNU General Public Licence.
  See the file COPYING in the main CLIB directory for details.
  Run "eprover -h" for contact information.

Changes

<1> Fri Oct 16 17:30:21 MET DST 1998
    New

-----------------------------------------------------------------------*/

#include "clb_simple_stuff.h"



/*---------------------------------------------------------------------*/
/*                        Global Variables                             */
/*---------------------------------------------------------------------*/


/*---------------------------------------------------------------------*/
/*                      Forward Declarations                           */
/*---------------------------------------------------------------------*/


/*---------------------------------------------------------------------*/
/*                         Internal Functions                          */
/*---------------------------------------------------------------------*/



/*---------------------------------------------------------------------*/
/*                         Exported Functions                          */
/*---------------------------------------------------------------------*/


/*-----------------------------------------------------------------------
//
// Function: StringIndex()
//
//   Given a NULL-Terminated array of strings, return the index of key
//   (or -1 if key does not occur in the array).
//
// Global Variables: -
//
// Side Effects    : -
//
/----------------------------------------------------------------------*/

int StringIndex(char* key, char* list[])
{
   int i;
   {
      for(i=0; list[i]; i++)
      {
	 if(strcmp(key, list[i])==0)
	 {
	    return i;
	 }
      }
   }
   return -1;
}
 
#ifdef NEED_MATH_EMULATION

/*-----------------------------------------------------------------------
//
// Function: sqrt()
//
//   Simple hack implementing the square root function, which seems
//   to be missing from Solars libm with profiling support. Don't ask
//   me... This is slow and inexact....
//
// Global Variables: -
//
// Side Effects    : Slow
//
/----------------------------------------------------------------------*/

double sqrt(double value)
{
   double lower, upper, guess, diff;

   assert(value>=0);
   
   lower = 0; 
   upper = value;
   guess = (lower+upper)/2;
   diff = (guess*guess)-value;

   while(ABS(diff)>0.00001)
   {
      if(diff>0)
      {
	 upper = guess;
      }
      else
      {
	 lower = guess;
      }
      guess = (lower+upper)/2;
      diff = (guess*guess)-value;      
   }
   return guess;
}

/*-----------------------------------------------------------------------
//
// Function: pow()
//
//   Compute x**y. See above.
//
// Global Variables: -
//
// Side Effects    : Wrong result...
//
/----------------------------------------------------------------------*/

double pow(double x, double y)
{
   return x;
}


#endif


/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/


